locale MMIsar0 =
  fixes real ("\<real>")
  fixes complex ("\<complex>")
  fixes one ("\<one>")
  fixes zero ("\<zero>")
  fixes iunit ("\<i>")
  fixes caddset ("\<caddset>")
  fixes cmulset ("\<cmulset>")
  fixes lessrrel ("\<lsrset>")

  fixes ca (infixl "\<ca>" 69)
  defines ca_def: "a \<ca> b \<equiv> \<caddset>`\<langle>a,b\<rangle>"
  fixes cm (infixl "\<cdot>" 71)
  defines cm_def: "a \<cdot> b \<equiv> \<cmulset>`\<langle>a,b\<rangle>"
  fixes sub (infixl "\<cs>" 69)
  defines sub_def: "a \<cs> b \<equiv> \<Union> { x \<in> \<complex>. b \<ca> x = a }"
  fixes cneg ("\<cn>_" 95)
  defines cneg_def: "\<cn> a \<equiv> \<zero> \<cs> a"
  fixes cdiv (infixl "\<cdiv>" 70)
  defines cdiv_def: "a \<cdiv> b \<equiv> \<Union> { x \<in> \<complex>. b \<cdot> x = a }"
  fixes cpnf ("\<cpnf>")
  defines cpnf_def: "\<cpnf> \<equiv> \<complex>"
  fixes cmnf ("\<cmnf>")
  defines cmnf_def: "\<cmnf> \<equiv> {\<complex>}"
  fixes cxr ("\<real>\<^isup>*")
  defines cxr_def: "\<real>\<^isup>* \<equiv> \<real> \<union> {\<cpnf>,\<cmnf>}"
  fixes cxn ("\<nat>")
  defines cxn_def: "\<nat> \<equiv> \<Inter> {N \<in> Pow(\<real>). \<one> \<in> N \<and> (\<forall>n. n\<in>N \<longrightarrow> n\<ca>\<one> \<in> N)}"
  fixes lessr (infix "\<lsr>" 68)
  defines lessr_def: "a \<lsr> b \<equiv> \<langle>a,b\<rangle> \<in> \<lsrset>"
  fixes cltrrset ("\<cltrrset>")
  defines cltrrset_def: 
  "\<cltrrset> \<equiv> (\<lsrset> \<inter> \<real>\<times>\<real>) \<union> {\<langle>\<cmnf>,\<cpnf>\<rangle>} \<union> 
  (\<real>\<times>{\<cpnf>}) \<union> ({\<cmnf>}\<times>\<real> )"
  fixes cltrr (infix "\<ls>" 68)
  defines cltrr_def: "a \<ls> b \<equiv> \<langle>a,b\<rangle> \<in> \<cltrrset>"
  fixes convcltrr (infix ">" 68)
  defines convcltrr_def: "a > b \<equiv> \<langle>a,b\<rangle> \<in> converse(\<cltrrset>)"
  fixes lsq (infix "\<lsq>" 68)
  defines lsq_def: "a \<lsq> b \<equiv> \<not> (b \<ls> a)"
  fixes two ("\<two>")
  defines two_def: "\<two> \<equiv> \<one>\<ca>\<one>"
  fixes three ("\<three>")
  defines three_def: "\<three> \<equiv> \<two>\<ca>\<one>"
  fixes four ("\<four>")
  defines four_def: "\<four> \<equiv> \<three>\<ca>\<one>"
  fixes five ("\<five>")
  defines five_def: "\<five> \<equiv> \<four>\<ca>\<one>"
  fixes six ("\<six>")
  defines six_def: "\<six> \<equiv> \<five>\<ca>\<one>"
  fixes seven ("\<seven>")
  defines seven_def: "\<seven> \<equiv> \<six>\<ca>\<one>"
  fixes eight ("\<eight>")
  defines eight_def: "\<eight> \<equiv> \<seven>\<ca>\<one>"
  fixes nine ("\<nine>")
  defines nine_def: "\<nine> \<equiv> \<eight>\<ca>\<one>"

  assumes MMI_pre_axlttri: 
  "A \<in> \<real> \<and> B \<in> \<real> \<longrightarrow> (A \<lsr> B \<longleftrightarrow> \<not>(A=B \<or> B \<lsr> A))"
  assumes MMI_pre_axlttrn: 
  "A \<in> \<real> \<and> B \<in> \<real> \<and> C \<in> \<real> \<longrightarrow> ((A \<lsr> B \<and> B \<lsr> C) \<longrightarrow> A \<lsr> C)"
  assumes MMI_pre_axltadd:
  "A \<in> \<real> \<and> B \<in> \<real> \<and> C \<in> \<real> \<longrightarrow> (A \<lsr> B \<longrightarrow> C\<ca>A \<lsr> C\<ca>B)"
  assumes MMI_pre_axmulgt0:
  "A \<in> \<real> \<and> B \<in> \<real> \<longrightarrow> ( \<zero> \<lsr> A \<and> \<zero> \<lsr> B \<longrightarrow> \<zero> \<lsr> A\<cdot>B)"
  assumes MMI_pre_axsup:
  "A \<subseteq> \<real> \<and> A \<noteq> 0 \<and> (\<exists>x\<in>\<real>. \<forall>y\<in>A. y \<lsr> x) \<longrightarrow>
  (\<exists>x\<in>\<real>. (\<forall>y\<in>A. \<not>(x \<lsr> y)) \<and> (\<forall>y\<in>\<real>. (y \<lsr> x \<longrightarrow> (\<exists>z\<in>A. y \<lsr> z))))"
  assumes MMI_axresscn: "\<real> \<subseteq> \<complex>"
  assumes MMI_ax1ne0: "\<one> \<noteq> \<zero>"
  assumes MMI_axcnex: "\<complex> isASet"
  assumes MMI_axaddopr: "\<caddset> : ( \<complex> \<times> \<complex> ) \<rightarrow> \<complex>"
  assumes MMI_axmulopr: "\<cmulset> : ( \<complex> \<times> \<complex> ) \<rightarrow> \<complex>"
  assumes MMI_axmulcom: "A \<in> \<complex> \<and> B \<in> \<complex> \<longrightarrow> A \<cdot> B = B \<cdot> A"
  assumes MMI_axaddcl: "A \<in> \<complex> \<and> B \<in> \<complex> \<longrightarrow> A \<ca> B \<in> \<complex>"
  assumes MMI_axmulcl: "A \<in> \<complex> \<and> B \<in> \<complex> \<longrightarrow> A \<cdot> B \<in> \<complex>"
  assumes MMI_axdistr: 
  "A \<in> \<complex> \<and> B \<in> \<complex> \<and> C \<in> \<complex> \<longrightarrow> A\<cdot>(B \<ca> C) = A\<cdot>B \<ca> A\<cdot>C" 
  assumes MMI_axaddcom: "A \<in> \<complex> \<and> B \<in> \<complex> \<longrightarrow> A \<ca> B = B \<ca> A"
  assumes MMI_axaddass: 
  "A \<in> \<complex> \<and> B \<in> \<complex> \<and> C \<in> \<complex> \<longrightarrow> A \<ca> B \<ca> C = A \<ca> (B \<ca> C)"
  assumes MMI_axmulass: 
  "A \<in> \<complex> \<and> B \<in> \<complex> \<and> C \<in> \<complex> \<longrightarrow> A \<cdot> B \<cdot> C = A \<cdot> (B \<cdot> C)"
  assumes MMI_ax1re: "\<one> \<in> \<real>"
  assumes MMI_axi2m1: "\<i> \<cdot> \<i> \<ca> \<one> = \<zero>"
  assumes MMI_ax0id: "A \<in> \<complex> \<longrightarrow> A \<ca> \<zero> = A"
  assumes MMI_axicn: "\<i> \<in> \<complex>"
  assumes MMI_axnegex: "A \<in> \<complex> \<longrightarrow> ( \<exists> x \<in> \<complex>. ( A \<ca> x ) = \<zero> )"
  assumes MMI_axrecex: "A \<in> \<complex> \<and> A \<noteq> \<zero> \<longrightarrow> ( \<exists> x \<in> \<complex>. A \<cdot> x = \<one>)"
  assumes MMI_ax1id: "A \<in> \<complex> \<longrightarrow> A \<cdot> \<one> = A"
  assumes MMI_axaddrcl: "A \<in> \<real> \<and> B \<in> \<real> \<longrightarrow> A \<ca> B \<in> \<real>"
  assumes MMI_axmulrcl: "A \<in> \<real> \<and> B \<in> \<real> \<longrightarrow> A \<cdot> B \<in> \<real>"
  assumes MMI_axrnegex: "A \<in> \<real> \<longrightarrow> ( \<exists> x \<in> \<real>. A \<ca> x = \<zero> )"
  assumes MMI_axrrecex: "A \<in> \<real> \<and> A \<noteq> \<zero> \<longrightarrow> ( \<exists> x \<in> \<real>. A \<cdot> x = \<one> )"